<template>
  <div id="container">
    <div id="mapContainer" v-bind:style="{width: width, height: height }"></div>
  </div>
</template>

<script>
import "leaflet/dist/leaflet.css";
import L from "leaflet";

export default {
  name: "OpenMap",
  props: {
    center: Object,
    lat: 0,
    lng: 0,
    width: String,
    height: String,
    id: String
  },
  data() {
    return {
       map: null
    }
  },
  methods: {
    setupLeafletMap: function () {
      console.log(this.center)
      this.map = L.map("mapContainer").setView(this.center, 18);
      L.tileLayer("http://{s}.tile.osm.org/{z}/{x}/{y}.png", {
        attribution:
            '&copy; <a href="http://osm.org/copyright%22%3EOpenStreetMap</a> contributors'
      }).addTo(this.map);

      let icon = L.divIcon({
        className: 'custom-div-icon',
        html: "<div style='background-color:#c30b82;' class='marker-pin'></div><i class='fa fa-info awesome'></i>",
        iconSize: [30, 42],
        iconAnchor: [15, 42]
      });

      let mark = L.marker(L.latLng(this.lat, this.lng), { icon: icon })
      mark.addTo(this.map)
    }
  },
  beforeDestroy() {
    if (this.map) {
      this.map.remove()
    }
  },
  mounted() {
    this.setupLeafletMap();
  },
};
</script>

<style scoped>
  /*#mapContainer {*/
  /*  width: 100%;*/
  /*  height: 300px;*/
  /*}*/

  .marker-pin {
    width: 30px;
    height: 30px;
    border-radius: 50% 50% 50% 0;
    background: #c30b82;
    position: absolute;
    transform: rotate(-45deg);
    left: 50%;
    top: 50%;
    margin: -15px 0 0 -15px;
  }
   .marker-pin::after {
     content: '';
     width: 24px;
     height: 24px;
     margin: 3px 0 0 3px;
     background: #fff;
     position: absolute;
     border-radius: 50%;
   }

   .custom-div-icon i {
     position: absolute;
     width: 22px;
     font-size: 22px;
     left: 0;
     right: 0;
     margin: 10px auto;
     text-align: center;
   }
  .custom-div-icon i.awesome {
    margin: 12px auto;
    font-size: 17px;
    color: #fff;
  }
</style>